export interface Listener<T> {
    (event: T): any;
}
export interface Disposable {
    dispose(): any;
}
export declare class PropertyChangedArgs<T> {
    constructor(newValue?: T, oldValue?: T);
    oldValue: T;
    newValue: T;
}
export declare class TypedEvent<T> {
    private listeners;
    private listenersOncer;
    private listenerSingle;
    on: (listener: Listener<T>) => Disposable;
    single: (listener: Listener<T>) => Disposable;
    once: (listener: Listener<T>) => void;
    off: (listener: Listener<T>) => void;
    emit: (event: T) => void;
    pipe: (te: TypedEvent<T>) => Disposable;
}
